Bug: https://bugs.gentoo.org/744880
Signed-off-by: Sam James <s...@gentoo.org>
---
 eclass/edo.eclass | 34 ++++++++++++++++++++++++++++++++++
 1 file changed, 34 insertions(+)
 create mode 100644 eclass/edo.eclass

diff --git a/eclass/edo.eclass b/eclass/edo.eclass
new file mode 100644
index 000000000000..fc025ddf4503
--- /dev/null
+++ b/eclass/edo.eclass
@@ -0,0 +1,34 @@
+# Copyright 2022 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+# @ECLASS: edo.class
+# @MAINTAINER:
+# QA Team <q...@gentoo.org>
+# @AUTHOR:
+# Sam James <s...@gentoo.org>
+# @SUPPORTED_EAPIS: 8
+# @BLURB: Convenience function to run commands verbosely and die on failure
+# @DESCRIPTION:
+# This eclass provides the 'edo' command which dies (exits) on failure
+# and logs the command used verbosely.
+#
+
+case ${EAPI:-0} in
+       8) ;;
+       *) die "${ECLASS}: EAPI ${EAPI:-0} not supported" ;;
+esac
+
+if [[ -z ${_EDO_ECLASS} ]] ; then
+ _EDO_CLASS=1
+
+# @FUNCTION: edo
+# @USAGE: command [arg1 [arg2 ...]]
+# @DESCRIPTION:
+# Executes 'command' with any given arguments and exits on failure unless
+# called under 'nonfatal'.
+edo() {
+       elog "$@"
+       "$@" || die -n "Failed to run command: $@ failed"
+}
+
+fi
-- 
2.35.1


Reply via email to